--- src/enfuse.cc.orig	2017-10-29 15:53:13 UTC
+++ src/enfuse.cc
@@ -105,6 +105,7 @@ std::optional<std::string> OutputMaskFileName;
 int Verbose = 0;                //< default-verbosity-level 0
 int ExactLevels = 0;            // 0 means: automatically calculate maximum
 bool OneAtATime = true;
+bool CopyMetadata = true;
 boundary_t WrapAround = OpenBoundaries;
 bool GimpAssociatedAlphaHack = false;
 blend_colorspace_t BlendColorspace = UndeterminedColorspace;
@@ -205,7 +206,8 @@ template <typename InputPixelType, typename ResultPixe
 double* enblend::Histogram<InputPixelType, ResultPixelType>::precomputedEntropy = nullptr;
 
 
-#define DUMP_GLOBAL_VARIABLES(...) dump_global_variables(__FILE__, __LINE__, ##__VA_ARGS__)
+//#define DUMP_GLOBAL_VARIABLES(...) dump_global_variables(__FILE__, __LINE__, ##__VA_ARGS__)
+#define DUMP_GLOBAL_VARIABLES() dump_global_variables(__FILE__, __LINE__)
 void dump_global_variables(const char* file, unsigned line,
                            std::ostream& out = std::cout)
 {
@@ -213,10 +215,11 @@ void dump_global_variables(const char* file, unsigned 
         "+ " << file << ":" << line << ": state of global variables\n" <<
         "+ Verbose = " << Verbose << ", option \"--verbose\"\n" <<
         "+ OutputFileName = <" << OutputFileName << ">\n" <<
-        "+ OutputMaskFileName = <" << OutputMaskFileName.value_or("<not defined>") << ">\n" <<
+        "+ OutputMaskFileName = <" << OutputMaskFileName.get_value_or("<not defined>") << ">\n" <<
         "+ ExactLevels = " << ExactLevels << "\n" <<
         "+ UseGPU = " << UseGPU << "\n" <<
         "+ OneAtATime = " << enblend::stringOfBool(OneAtATime) << ", option \"-a\"\n" <<
+        "+ CopyMetadata = " << enblend::stringOfBool(CopyMetadata) << ", option \"--[no-]metadata\"\n" <<
         "+ WrapAround = " << enblend::stringOfWraparound(WrapAround) << ", option \"--wrap\"\n" <<
         "+ GimpAssociatedAlphaHack = " << enblend::stringOfBool(GimpAssociatedAlphaHack) <<
         ", option \"-g\"\n" <<
@@ -529,6 +532,7 @@ void sigint_handler(int sig)
 
 enum AllPossibleOptions {
     VersionOption, HelpOption, LevelsOption, OutputOption, OutputMaskOption, VerboseOption,
+    MetadataOption, NoMetadataOption,
     WrapAroundOption /* -w */, CompressionOption, LZWCompressionOption,
     BlendColorspaceOption, FallbackProfileOption,
     DepthOption, AssociatedAlphaOption /* -g */,
@@ -889,6 +893,8 @@ process_options(int argc, char** argv)
 {
     enum OptionId {
         OPTION_ID_OFFSET = 1023,    // Ids start at 1024
+        MetadataId,
+        NoMetadataId,
         UseGpuId,
         NoUseGpuId,
         PreferGpuId,
@@ -932,6 +938,8 @@ process_options(int argc, char** argv)
     };
 
     static struct option long_options[] = {
+        {"metadata", no_argument, 0, MetadataId},
+        {"no-metadata", no_argument, 0, NoMetadataId},
         {"gpu", no_argument, 0, UseGpuId},
         {"no-gpu", no_argument, 0, NoUseGpuId},
         {"prefer-gpu", required_argument, 0, PreferGpuId},
@@ -1009,6 +1017,16 @@ process_options(int argc, char** argv)
         }
 
         switch (code) {
+        case MetadataId:
+            CopyMetadata = true;
+            optionSet.insert(MetadataOption);
+            break;
+
+        case NoMetadataId:
+            CopyMetadata = false;
+            optionSet.insert(NoMetadataOption);
+            break;
+
         case UseGpuId:
             UseGPU = true;
             optionSet.insert(GPUOption);
