--- src/opencl.cc.orig	2017-02-13 07:55:01 UTC
+++ src/opencl.cc
@@ -31,6 +31,8 @@
 
 #include "opencl.h"
 
+//#define ENB_CL_DEVICE_TYPE	(CL_DEVICE_TYPE_GPU|CL_DEVICE_TYPE_CPU)
+#define ENB_CL_DEVICE_TYPE	(CL_DEVICE_TYPE_GPU)
 
 namespace ocl
 {
@@ -533,7 +535,7 @@ namespace ocl
                 device_list_t devices;
                 try
                 {
-                    p->getDevices(all_devices ? CL_DEVICE_TYPE_ALL : CL_DEVICE_TYPE_GPU, &devices);
+                    p->getDevices(all_devices ? CL_DEVICE_TYPE_ALL : ENB_CL_DEVICE_TYPE, &devices);
                 }
                 catch (cl::Error& an_error)
                 {
@@ -652,7 +654,7 @@ namespace ocl
                                  [](const cl::Platform& a_platform)
                                  {
                                      ocl::device_list_t devices;
-                                     try {a_platform.getDevices(CL_DEVICE_TYPE_GPU, &devices);}
+                                     try {a_platform.getDevices(ENB_CL_DEVICE_TYPE, &devices);}
                                      catch (cl::Error&) {return false;}
                                      return devices.size() >= 1U;
                                  });
@@ -689,7 +691,7 @@ namespace ocl
 
         try
         {
-            a_platform.getDevices(CL_DEVICE_TYPE_GPU, &some_devices);
+            a_platform.getDevices(ENB_CL_DEVICE_TYPE, &some_devices);
         }
         catch (cl::Error& an_error)
         {
@@ -843,6 +845,14 @@ namespace ocl
         else if (is_prefix_of_name("NVIDIA"))
         {
             return vendor::nvidia;
+        }
+        else if (is_prefix_of_name("Intel"))
+        {
+            return vendor::intel;
+        }
+        else if (is_prefix_of_name("Mesa"))
+        {
+            return vendor::mesa;
         }
         else
         {
